﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ReportingSourceTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            DataContext = new DataSource() { Sources = new List<Source> { new Source() } };

            Loaded += MainWindow_Loaded;
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            TextBox tb = xamReportViewer.FindName("TbxPageNumber") as TextBox;
            //TbxPageNumber
        }

        private void btn_Click(object sender, RoutedEventArgs e)
        {
            // Set PDF format for export
            // should be one within XamReportViewer.AvailableExportFormats
            string exportFormat = "PDF";

            SaveFileDialog saveFileDialog = new SaveFileDialog()
            {
                DefaultExt = exportFormat,
                Filter = "PDF files (*.pdf)|*.pdf|All files (*.*)|*.*",
                FilterIndex = 1
            };

            // Instantiate a SaveFileDialog to specify file destination
            if (saveFileDialog.ShowDialog() == true)
            {
                Stream myStream = null;
                try
                {
                    // Open a file to save the exported report
                    myStream = saveFileDialog.OpenFile();

                    // Invoke Viewer's Exporter
                    this.xamReportViewer.Export(myStream, exportFormat);
                }
                catch (Exception)
                {
                    //TODO  Handle Exception
                    if (myStream != null)
                        myStream.Close();
                }
            }
        }

        private void xamReportViewer_ExportCompleted(object sender, Infragistics.Reports.ExportCompletedEventArgs e)
        {
            if (e.Stream != null)
            {
                // Stream needs to be closed
                Dispatcher.BeginInvoke(new Action(() => e.Stream.Close()));
            }

            System.Diagnostics.Process.Start(@"C:\Users\mreymann\Desktop\file.pdf");
        }
    }

    public class DataSource
    {
        List<Source> _sources;
        public List<Source> Sources
        {
            get
            {   
                return _sources;
            }
            set
            {
                _sources = value;
            }
        }
    }

    public class Source
    {
        public Source()
        {
            First = new List<Data>();
            Second = new List<Data>();
           
            Random r = new Random();           
            for (int i = 1; i < 4; i++)
            {
                Data d = new Data();
                d.ID = i;
                d.Name = "first" + i.ToString();
                d.X = i;
                d.Y0 = r.Next(10, 150);
                d.Y1 = r.Next(30,150);                
                First.Add(d);
       

                Data d2 = new Data();
                d2.ID = i;
                d2.Name = "second" + i.ToString();
                d2.X = i;
                d2.Y0 = r.Next(10, 150);
                d2.Y1 = r.Next(30, 150); 
                Second.Add(d2);               
            }   
        }


        public List<Data> First { get; set; }
        public List<Data> Second { get; set; }
     
        
    }

    public class Data
    {
        public int ID { get; set; }
        public string Name { get; set; }
        public int X { get; set; }
        public int Y0 { get; set; }
        public int Y1 { get; set; }
       
    }
}
